
program prob
  use dislin
  implicit none
  !este programa coge el archivo li_geninterp.dat y se queda unicamente con la banda 1
  
  integer::numero_puntos_k
  integer::n,i,j,k,t
  real::k_x,k_y,k_z,E
  integer::N_ptos !el numero de ptos en cada direccion del mallado
  real::paso,kx_0,ky_0,kz_0
  real,dimension(:),allocatable::xray,yray,zray
  real,dimension(:,:,:),allocatable::valor_funcion
!para isopts
  integer::NMAX,NTRI
  real,dimension(:),allocatable::XTRI,YTRI,ZTRI
!para pasar a coord cartesianas
  real,dimension(3,1)::vector_crist,vector_cart
  real,dimension(3,3)::matriz_cambio_base,matriz_cart_crist
  real,dimension(3)::punto_1,punto_2,punto_3,baricentro,baricentro_prueba,baricentro_prueba_2
  real,dimension(3)::b_1,b_2,b_3,G
  real::pi,a

  open(unit=1,file="li_geninterp.dat",status="old",action="read")
  open(unit=2,status="scratch",action="readwrite")
  open(unit=3,status="scratch",action="readwrite")
  open(unit=4,status="scratch",action="readwrite")  
  open(unit=10,status="scratch",action="readwrite")
  open(unit=11,status="scratch",action="readwrite")
  open(unit=12,file="vertices_triangulos_cartesianas_primera_zona.dat",status="replace",action="readwrite")
  open(unit=13,file="li_geninterp_velfermi.kpt",status="replace",action="readwrite") !este archivo sera el que introduzca como input en postw90 
!para calcular la velocidad de fermi en los baricentros deseados.


  pi=acos(-1.0)
  a=6.5973*0.529177 !pasamos de bohr a angstrom el parametro de red que es lo que necesitamos en el input de wannier90

   N_ptos=41
   numero_puntos_k=N_ptos**3
   j=0
 do i=1,4*numero_puntos_k
     read(unit=1,fmt=*)n,k_x,k_y,k_z,E
     !solo me interesa la primera banda
     j=j+1
     if (j==1) then
        write(unit=2,fmt=*)k_x,k_y,k_z,E
        j=-3
     endif  
  enddo

!---------------------------------------------------------------------------------
!ahora generamos los datos para meterlos en DISLIN
 rewind(unit=2)
    paso=1.0/real(N_ptos-1)
    kx_0=0
    ky_0=0
    kz_0=0
    allocate(xray(N_ptos))
    allocate(yray(N_ptos))
    allocate(zray(N_ptos))
    allocate(valor_funcion(N_ptos,N_ptos,N_ptos))

        do k=0,N_ptos-1
           xray(k+1)=kx_0+paso*k
           yray(k+1)=ky_0+paso*k
           zray(k+1)=kz_0+paso*k
         enddo

    do i=1,N_ptos
      do j=1,N_ptos
        do k=1,N_ptos
           read(unit=2,fmt=*)k_x,k_y,k_z,valor_funcion(i,j,k)
         enddo
      enddo
    enddo

 NMAX=1000000 ! maximo numero de triangulos que puedo tener. Necesario poner en isopts
 allocate(XTRI(NMAX))
 allocate(YTRI(NMAX))
 allocate(ZTRI(NMAX))
  call scrmod("REVERS") !poniendo esto el fondo es blanco y la representacion es negra 
  call metafl("CONS")!para que salga por pantalla. Se puede poner que salga en pdf poniendo "PDF"
  call disini()

 !FORMATO PARA PONER TITULOS:
 !PONEMOS CALL TITLIN ("TITULO QUE QUEREMOS PONER",NUMERO)
 !PARA QUE APAREZCA EL TITULO PONER ANTES DEL CALL DISFIN CALL TITLE().
 !AL PONER EN NUMERO=1 EL TITULO SE PONE MUY ARRIBA. AL PONER NUMERO=4 NOS LO PONE CERCA DEL GRAFICO. AL PONER NUMERO=-1 NOS SUBRAYA EL TITULO Y 
 ! LO PONE ALEJADO. AL PONER NUMERO=-4 LO SUBRAYA Y LO PONE CERCA DEL GRAFICO.
  call titlin("sup de Fermi",-4)
!definimos los nombres de los ejes. Primero se pone el nombre que queremos que aparezca en el eje y en el segundo se pone como le hacemos referencia.  
  call name ("b1-AXIS","x")
  call name ("b2-AXIS","Y")
  call name ("b3-AXIS","Z")
 
  call graf3d(0.0,1.0,0.0,0.2,0.0,1.0,0.0,0.2,0.0,1.0,0.0,0.2) !ES OBLIGATORIO EN CUALQUIER GRAFICO 3D
  call isopts(xray,N_ptos,yray,N_ptos,zray,N_ptos,valor_funcion,0.3513,XTRI,YTRI,ZTRI,NMAX,NTRI)  
  print *, "el numero de triangulos que tenemos es:",NTRI/3
!generamos la matriz de cambio de base de coord cristalinas a cartesianas en unidades de 2pi/a (para la celda reciproca)
 
  matriz_cambio_base(1,1)=1
  matriz_cambio_base(1,2)=-1
  matriz_cambio_base(1,3)=0
  matriz_cambio_base(2,1)=0
  matriz_cambio_base(2,2)=1
  matriz_cambio_base(2,3)=-1
  matriz_cambio_base(3,1)=1
  matriz_cambio_base(3,2)=0
  matriz_cambio_base(3,3)=1
 
 do j=1,NTRI 
      vector_crist(1,1)=XTRI(j)
      vector_crist(2,1)=YTRI(j)
      vector_crist(3,1)=ZTRI(j)
      vector_cart=matmul(matriz_cambio_base,vector_crist)
      write(unit=12,fmt=*)vector_cart(1,1),vector_cart(2,1),vector_cart(3,1) 
  enddo

  rewind(unit=12)
  do t=1,NTRI/3
     read(unit=12,fmt=*)punto_1(1),punto_1(2),punto_1(3)
     read(unit=12,fmt=*)punto_2(1),punto_2(2),punto_2(3)
     read(unit=12,fmt=*)punto_3(1),punto_3(2),punto_3(3)

   baricentro(1)=(punto_1(1)+punto_2(1)+punto_3(1))/3.0
   baricentro(2)=(punto_1(2)+punto_2(2)+punto_3(2))/3.0
   baricentro(3)=(punto_1(3)+punto_2(3)+punto_3(3))/3.0

  write(unit=11,fmt=*)baricentro(1),baricentro(2),baricentro(3)
 enddo
!---------------------------------------------------------------------------------------------------------------------------
!a partir de aqui generamos el archivo de texto que meteremos como input de geninterp. En el metemos las coordenadas de cada baricentro en 
!la primera zona de Brillouin 
  rewind(unit=11)
  write(unit=13,fmt=*)"segundo input de wannier cuya salida es li_geninterp_2.dat"
  write(unit=13,fmt=*)"cart"   
  write(unit=13,fmt=*)NTRI/3 !el numero de baricentros en los que tengo que calcular la velocidad de fermi 
  
  do j=1,NTRI/3
        read(unit=11,fmt=*)vector_cart(1,1),vector_cart(2,1),vector_cart(3,1)
        write(unit=13,fmt=*)j,2*pi/a*vector_cart(1,1),2*pi/a*vector_cart(2,1),2*pi/a*vector_cart(3,1)
  enddo
  
  call title ()
  call box3d()    
 call disfin()        
end program prob
