program prob
  use dislin
  implicit none
  real,dimension(:),allocatable::vertices_x,vertices_y,vertices_z,v_fermi
  integer,dimension(:),allocatable::colores
  integer,dimension(:),allocatable::color_baricentro
  integer::NTRI,j,i,n,t
  real::v_x,v_y,v_z,v,k_x,k_y,k_z,E,z_min,z_max
!------------------------------------------------------------------------------------
     real :: bg(3,3), kc(3),k_gamma(3),kc_1(3),primer_vertice(3),segundo_vertice(3),tercer_vertice(3)
     real::v_fermi_2 !es para no confundirla con el vector definido arriba
     real,parameter::pi=acos(-1.0),a=6.5973*0.529177
     integer::vector_auxiliar(3)
      real::primer_vertice_aux(3),segundo_vertice_aux(3),tercer_vertice_aux(3)
  NTRI=16472*3 !lo he sacado a mano del input de programa.f90

  open(unit=12,file="vertices_triangulos_cartesianas_primera_zona.dat",status="old",action="readwrite")
  open(unit=13,file="li_geninterp_2.dat",status="old",action="readwrite")
  open(unit=14,file="velocidad_fermi_puntos_k.dat",status="replace",action="readwrite")
  open(unit=19,file="bg.dat", status="unknown")
  open(unit=20,file="pkf1zb.dat",status="unknown")

  allocate(vertices_x(NTRI))
  allocate(vertices_y(NTRI))
  allocate(vertices_z(NTRI))
  allocate(colores(NTRI))
  allocate(v_fermi(NTRI/3))
  allocate(color_baricentro(NTRI/3))
   t=0
   j=0
  do i=1,4*NTRI/3
     read(unit=13,fmt=*)n,k_x,k_y,k_z,E,v_x,v_y,v_z
     !solo me interesa la primera banda
     j=j+1
     if (j==1) then
        v=sqrt(v_x**2+v_y**2+v_z**2)
            write(unit=14,fmt=*)k_x,k_y,k_z,v
            t=t+1
            v_fermi(t)=v
            j=-3
     endif  
  enddo
    
     rewind(unit=14)
     rewind(unit=12)

     do i=1,3 
        read(unit=19,fmt=*) (bg(i,j), j=1,3) 
     enddo
!---------------------------------------------------------------------------------------------------------------------------------------------------------------
!explicación del motivo del factor 0.06943734 en las siguientes lineas. Se trata del factor por el que hay que multplicar para
!para pasar la velocidad a las unidades atomicas.
!El programa calcula las derivadas en unidades de eV*A donde A significa Angstrom. Lo primero es pasar
!esta cantidad al SI (J*m). Para ello se utilizan las relaciones:    1eV=1.6*10^-19J, 1A=10^-10m
!Por tanto, hay que multplicar este termino por 1.6*10^-29.
!Despues, utilizando el modelo semiclasico se calcula la velocidad dividiendo esta derivada entre h/(2*pi). Asi, 
!multiplico por (2*pi) y divido entre 6.62*10^-34. Esto nos deja la velocidad en m/s.
!finalmente recurrimos a una tabla de unidades donde se observa que el paso del SI a las unidades atómicas de una cantidad en m/s se realiza 
!dividiendo entre 2.187*10^6. El resultado de todas estas operaciones es 0.06943734
!----------------------------------------------------------------------------------------------------------------------------------------------------------
     do i=1,NTRI/3 
             read(unit=14,fmt=*)kc(1:3),v_fermi_2
             read(unit=12,fmt=*)primer_vertice(1:3)
             read(unit=12,fmt=*)segundo_vertice(1:3)
             read(unit=12,fmt=*)tercer_vertice(1:3)
             kc_1=a/2/pi*kc
             vector_auxiliar=kcg(kc_1,bg)
             k_gamma=kc_1+matmul(bg,vector_auxiliar)
             primer_vertice_aux=primer_vertice+matmul(bg,vector_auxiliar)
             segundo_vertice_aux=segundo_vertice+matmul(bg,vector_auxiliar)
             tercer_vertice_aux=tercer_vertice+matmul(bg,vector_auxiliar)             
            write(unit=21,fmt=*)primer_vertice_aux(1:3),0.06943734*v_fermi_2
            write(unit=21,fmt=*)segundo_vertice_aux(1:3),0.06943734*v_fermi_2
            write(unit=21,fmt=*)tercer_vertice_aux(1:3),0.06943734*v_fermi_2
             write(unit=20,fmt=*)k_gamma(1:3),v_fermi_2
     end do      
 contains
     function kcg ( kc , bg) result(salida)  !esta funcion es la encargada de determinar el vector de la red reciproca G que desplazara el baricentro
     !a la primera zona de Brillouin.
         real,intent(in):: kc(3), bg(3,3)
         integer::i,j,k, ind(3)
         real,dimension(-2:2,-2:2,-2:2) :: dist
         integer :: salida (3)
         do i=-2,2
             do j=-2,2
                do k=-2,2
                     dist(i,j,k)= sum( (kc(1:3)+matmul(bg, (/i,j,k/)))**2 )
                 enddo
             enddo
         enddo
         ind=minloc(dist)
         i=ind(1)
         j=ind(2)
         k=ind(3)
         i=i-3  !esto lo pongo porque FORTRAN coge como que la matriz va de 1:5 en vez de -2:2
         j=j-3
         k=k-3
         salida=(/i,j,k/) 
     end function kcg 
end program prob

