program programa
    use dislin
   implicit none

    real,dimension(3)::vertice_1,vertice_2,vertice_3,salida,baricentro,AB,AC,Obaricentro
    integer::i,NTRI
    real::v_fermi,z_min,z_max
    real,dimension(:),allocatable::vertices_x,vertices_y,vertices_z,v_fermi_vector
    integer,dimension(:),allocatable::colores
    open(unit=1,file="fort.21",status="old",action="read") !archivo con los vertices en coordenadas cartesianas en unidades de 
    !2pi/a desplazados a la primera zona
    open(unit=2,file="vertices_bien.dat",status="replace", action="readwrite")  

    NTRI=3*16472
    do i=1,16472 !16472 es el numero de triangulos que tenemos.
         read(unit=1,fmt=*)vertice_1(:),v_fermi
         read(unit=1,fmt=*)vertice_2(:)
         read(unit=1,fmt=*)vertice_3(:)
         baricentro(1)=(vertice_1(1)+vertice_2(1)+vertice_3(1))/3.0
         baricentro(2)=(vertice_1(2)+vertice_2(2)+vertice_3(2))/3.0
         baricentro(3)=(vertice_1(3)+vertice_2(3)+vertice_3(3))/3.0
         AB=vertice_2-vertice_1
         AC=vertice_3-vertice_1
         Obaricentro=baricentro/sqrt(sum(baricentro(:)**2))
         call prod_vector(AB,AC,salida)
         if (dot_product(salida,Obaricentro)>=0) then
                 write(unit=2,fmt=*)vertice_1(:),v_fermi
                 write(unit=2,fmt=*)vertice_2(:),v_fermi
                 write(unit=2,fmt=*)vertice_3(:),v_fermi
         else
                 write(unit=2,fmt=*)vertice_1(:),v_fermi
                 write(unit=2,fmt=*)vertice_3(:),v_fermi
                 write(unit=2,fmt=*)vertice_2(:),v_fermi 
         endif
    enddo
   rewind(unit=2)
  !----------------------------------------------------------------------------------------------------------------------------------------------------------
   allocate(vertices_x(NTRI))
  allocate(vertices_y(NTRI))
  allocate(vertices_z(NTRI))
  allocate(colores(NTRI))
  allocate(v_fermi_vector(NTRI))
  do i=1,16472*3
         read(unit=2,fmt=*)vertices_x(i),vertices_y(i),vertices_z(i),v_fermi_vector(i)
  enddo
   call disini()
 z_min=minval(v_fermi_vector)
 z_max=maxval(v_fermi_vector)
 print*,"el maximo valor de la velocidad es:",z_max
 print *, "el minimo valor de la velocidad es:",z_min
  CALL GRAF3 (-1.0, 3.0, -1.0, 0.2, -1.0, 3.0, -1.0, 0.2,z_min,z_max,z_min, 0.5)
 call colray(v_fermi_vector,colores,NTRI)
 call disfin()

print *, "primer paso realizado. Ya se conoce el color de cada triángulo. Ahora representamos la supericie de Fermi y la velocidad"

  call scrmod("REVERS") !poniendo esto el fondo es blanco y la representacion es negra 
  call metafl("PDF")!para que salga por pantalla. Se puede poner que salga en pdf poniendo "PDF"
  call disini()
  call HWFONT() !para que las letras sean mas elegantes 
  call name ("Kx-AXIS (2*pi/a)","x")
  call name ("Ky-AXIS (2*pi/a","Y")
  call name ("Kz-AXIS (2*pi/a)","Z")
  call graf3d(-1.0,1.0,-1.0,0.2,-1.0,1.0,-1.0,0.2,-1.0,1.0,-1.0,0.2) !ES OBLIGATORIO EN CUALQUIER GRAFICO 3D

 call vtxc3d(vertices_x,vertices_y,vertices_z,colores,NTRI,"trian")
  call title ()
 call disfin()   
print *, "En el archivo dislin.pdf se encuentra la superficie de Fermi y la velocidad"
!---------------------------------------------------------------------------------------------------------------------------------------------------------------
   contains
    subroutine prod_vector(v_1,v_2,salida) !esta subrutina calcula el producto vectorial de dos vectores.
           real,dimension(3),intent(in)::v_1,v_2
           real,dimension(3),intent(out)::salida
           salida(1)=v_1(2)*v_2(3)-v_1(3)*v_2(2)
           salida(2)=v_2(1)*v_1(3)-v_1(1)*v_2(3)
           salida(3)=v_1(1)*v_2(2)-v_2(1)*v_1(2)
     end subroutine prod_vector
end program programa
